// Generated by gtkmmproc -- DO NOT MODIFY!


#include <gstreamermm/ghostpad.h>
#include <gstreamermm/private/ghostpad_p.h>

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gstghostpad.h>
#include <gstreamermm/padtemplate.h>


namespace Gst
{

GhostPad::GhostPad(const Glib::ustring& name,
  const Glib::RefPtr<Gst::Pad>& target)
  : // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Pad(Glib::ConstructParams(ghostpad_class_.init(), "name",name.c_str(),"direction",(GstPadDirection) target->get_direction(), static_cast<char*>(0)))
{
  if (!gst_ghost_pad_construct(gobj()) ||
    !gst_ghost_pad_set_target(gobj(), target->gobj()))
  {
    g_warning("Gst::GhostPad::GhostPad(const Glib::ustring&,"
      " const Glib::RefPtr<Gst::Pad>&): "
      "Unsuccessful construction of ghost pad (name = %s, target = %s).",
      name.c_str(), target->get_name().c_str());
  }
}

GhostPad::GhostPad(const Glib::ustring& name, PadDirection direction)
  : // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Pad(Glib::ConstructParams(ghostpad_class_.init(), "name",name.c_str(),"direction",(GstPadDirection) direction, static_cast<char*>(0)))
{
  if (!gst_ghost_pad_construct(gobj()))
  {
    g_warning("Gst::GhostPad::GhostPad(const Glib::ustring&, PadDirection):"
    " Unsuccessful construction of ghost pad (name = %s, direction = %d).",
    name.c_str(), direction);
  }
}

GhostPad::GhostPad(const Glib::ustring& name,
  const Glib::RefPtr<Gst::Pad>& target,
  const Glib::RefPtr<Gst::PadTemplate>& templ)
  : // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Pad(Glib::ConstructParams(ghostpad_class_.init(), "name",name.c_str(),"direction",(GstPadDirection) target->get_direction(),"template",templ->gobj(), static_cast<char*>(0)))
{
  if (!gst_ghost_pad_construct(gobj()) ||
    !gst_ghost_pad_set_target(gobj(), target->gobj()))
  {
    g_warning("Gst::GhostPad::GhostPad(const Glib::ustring&,"
      " const Glib::RefPtr<Gst::Pad>&, const Glib::RefPtr<Gst::PadTemplate>&):"
        " Unsuccessful construction of ghost pad "
        "(name = %s, target = %s, templ = %s).",
        name.c_str(), target->get_name().c_str(),
        templ->get_name_template().c_str());
  }
}

GhostPad::GhostPad(const Glib::ustring& name,
  const Glib::RefPtr<Gst::PadTemplate>& templ)
  : // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Pad(Glib::ConstructParams(ghostpad_class_.init(), "name",name.c_str(),"direction",(GstPadDirection) templ->get_direction(),"template",templ->gobj(), static_cast<char*>(0)))
{
  if (!gst_ghost_pad_construct(gobj()))
  {
    g_warning("Gst::GhostPad::GhostPad(const Glib::ustring&,"
      " const Glib::RefPtr<Gst::PadTemplate>&): "
      "Unsuccessful construction of ghost pad (name = %s, templ = %s).",
      name.c_str(), templ->get_name_template().c_str());
  }
}

} //namespace Gst

namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gst::GhostPad> wrap(GstGhostPad* object, bool take_copy)
{
  return Glib::RefPtr<Gst::GhostPad>( dynamic_cast<Gst::GhostPad*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gst
{


/* The *_Class implementation: */

const Glib::Class& GhostPad_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &GhostPad_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gst_ghost_pad_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}

void GhostPad_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* GhostPad_Class::wrap_new(GObject* object)
{
  return new GhostPad((GstGhostPad*)object);
}


/* The implementation: */

GstGhostPad* GhostPad::gobj_copy()
{
  reference();
  return gobj();
}

GhostPad::GhostPad(const Glib::ConstructParams& construct_params)
:
  Pad(construct_params)
{

}

GhostPad::GhostPad(GstGhostPad* castitem)
:
  Pad((GstPad*)(castitem))
{}

GhostPad::~GhostPad()
{}


GhostPad::CppClassType GhostPad::ghostpad_class_; // initialize static member

GType GhostPad::get_type()
{
  return ghostpad_class_.init().get_type();
}

GType GhostPad::get_base_type()
{
  return gst_ghost_pad_get_type();
}


Glib::RefPtr<GhostPad> GhostPad::create(const Glib::ustring& name, const Glib::RefPtr<Gst::Pad>& target)
{
  return Glib::RefPtr<GhostPad>( new GhostPad(name, target) );
}
Glib::RefPtr<GhostPad> GhostPad::create(const Glib::ustring& name, PadDirection dir)
{
  return Glib::RefPtr<GhostPad>( new GhostPad(name, dir) );
}
Glib::RefPtr<GhostPad> GhostPad::create(const Glib::ustring& name, const Glib::RefPtr<Gst::Pad>& target, const Glib::RefPtr<Gst::PadTemplate>& templ)
{
  return Glib::RefPtr<GhostPad>( new GhostPad(name, target, templ) );
}
Glib::RefPtr<GhostPad> GhostPad::create(const Glib::ustring& name, const Glib::RefPtr<Gst::PadTemplate>& templ)
{
  return Glib::RefPtr<GhostPad>( new GhostPad(name, templ) );
}
bool GhostPad::set_target(const Glib::RefPtr<Gst::Pad>& newtarget)
{
  return gst_ghost_pad_set_target(gobj(), Glib::unwrap(newtarget));
}

Glib::RefPtr<Gst::Pad> GhostPad::get_target()
{
  return Glib::wrap(gst_ghost_pad_get_target(gobj()));
}

Glib::RefPtr<const Gst::Pad> GhostPad::get_target() const
{
  return const_cast<GhostPad*>(this)->get_target();
}


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Gst


